org.jboss.netty.handler.codec.serialization

## Class ObjectDecoder

- java.lang.Object
- - org.jboss.netty.channel.SimpleChannelUpstreamHandler
  - - org.jboss.netty.handler.codec.frame.FrameDecoder
    - - org.jboss.netty.handler.codec.frame.LengthFieldBasedFrameDecoder
      - - org.jboss.netty.handler.codec.serialization.ObjectDecoder

All Implemented Interfaces:
  ChannelHandler, ChannelUpstreamHandler, LifeCycleAwareChannelHandler

    public class ObjectDecoder
    extends LengthFieldBasedFrameDecoder

A decoder which deserializes the received `ChannelBuffer`s into Java objects.

Please note that the serialized form this decoder expects is not compatible with the standard `ObjectOutputStream`. Please use `ObjectEncoder` or `ObjectEncoderOutputStream` to ensure the interoperability with this decoder.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.jboss.netty.channel.ChannelHandler

`ChannelHandler.Sharable`

### Field Summary

### Fields inherited from class org.jboss.netty.handler.codec.frame.FrameDecoder

`cumulation, DEFAULT_MAX_COMPOSITEBUFFER_COMPONENTS`

### Constructor Summary

Constructors
Constructor and Description
`ObjectDecoder()` Deprecated. use `ObjectDecoder(ClassResolver)`
`ObjectDecoder(ClassResolver classResolver)` Creates a new decoder whose maximum object size is `1048576` bytes.
`ObjectDecoder(int maxObjectSize)` Deprecated. use `ObjectDecoder(int, ClassResolver)`
`ObjectDecoder(int maxObjectSize, ClassLoader classLoader)` Deprecated. use `ObjectDecoder(int, ClassResolver)`
`ObjectDecoder(int maxObjectSize, ClassResolver classResolver)` Creates a new decoder with the specified maximum object size.

### Method Summary

Methods
`protected Object` `decode(ChannelHandlerContext ctx, Channel channel, ChannelBuffer buffer)` Decodes the received packets so far into a frame.
`protected ChannelBuffer` `extractFrame(ChannelBuffer buffer, int index, int length)` Extract the sub-region of the specified buffer.

### Methods inherited from class org.jboss.netty.handler.codec.frame.FrameDecoder

`actualReadableBytes, afterAdd, afterRemove, appendToCumulation, beforeAdd, beforeRemove, channelClosed, channelDisconnected, cleanup, decodeLast, exceptionCaught, getMaxCumulationBufferCapacity, getMaxCumulationBufferComponents, internalBuffer, isUnfold, messageReceived, newCumulationBuffer, replace, setMaxCumulationBufferCapacity, setMaxCumulationBufferComponents, setUnfold, unfoldAndFireMessageReceived, updateCumulation`

### Methods inherited from class org.jboss.netty.channel.SimpleChannelUpstreamHandler

`channelBound, channelConnected, channelInterestChanged, channelOpen, channelUnbound, childChannelClosed, childChannelOpen, handleUpstream, writeComplete`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ObjectDecoder

    @Deprecated
    public ObjectDecoder()

Deprecated. use `ObjectDecoder(ClassResolver)`
Creates a new decoder whose maximum object size is `1048576` bytes. If the size of the received object is greater than `1048576` bytes, a `StreamCorruptedException` will be raised.

#### ObjectDecoder

    public ObjectDecoder(ClassResolver classResolver)

Creates a new decoder whose maximum object size is `1048576` bytes. If the size of the received object is greater than `1048576` bytes, a `StreamCorruptedException` will be raised.

Parameters:
  `classResolver` - the `ClassResolver` to use for this decoder

#### ObjectDecoder

    @Deprecated
    public ObjectDecoder(int maxObjectSize)

Deprecated. use `ObjectDecoder(int, ClassResolver)`
Creates a new decoder with the specified maximum object size.

Parameters:
  `maxObjectSize` - the maximum byte length of the serialized object. if the length of the received object is greater than this value, `StreamCorruptedException` will be raised.

#### ObjectDecoder

    public ObjectDecoder(int maxObjectSize,
                 ClassResolver classResolver)

Creates a new decoder with the specified maximum object size.

Parameters:
  `maxObjectSize` - the maximum byte length of the serialized object. if the length of the received object is greater than this value, `StreamCorruptedException` will be raised.
  `classResolver` - the `ClassResolver` which will load the class of the serialized object

#### ObjectDecoder

    @Deprecated
    public ObjectDecoder(int maxObjectSize,
                            ClassLoader classLoader)

Deprecated. use `ObjectDecoder(int, ClassResolver)`
Create a new decoder with the specified maximum object size and the `ClassLoader` wrapped in `ClassResolvers.weakCachingResolver(ClassLoader)`.

Parameters:
  `maxObjectSize` - the maximum byte length of the serialized object. if the length of the received object is greater than this value, `StreamCorruptedException` will be raised.
  `classLoader` - the the classloader to use

### Method Detail

#### decode

    protected Object decode(ChannelHandlerContext ctx,
                Channel channel,
                ChannelBuffer buffer)
                     throws Exception

Description copied from class: `FrameDecoder`
Decodes the received packets so far into a frame.

Overrides:
  `decode` in class `LengthFieldBasedFrameDecoder`
Parameters:
  `ctx` - the context of this handler
  `channel` - the current channel
  `buffer` - the cumulative buffer of received packets so far. Note that the buffer might be empty, which means you should not make an assumption that the buffer contains at least one byte in your decoder implementation.
Returns:
  the decoded frame if a full frame was received and decoded. `null` if there's not enough data in the buffer to decode a frame.
Throws:
  `Exception`

#### extractFrame

    protected ChannelBuffer extractFrame(ChannelBuffer buffer,
                             int index,
                             int length)

Description copied from class: `LengthFieldBasedFrameDecoder`
Extract the sub-region of the specified buffer. This method is called by `LengthFieldBasedFrameDecoder.decode(ChannelHandlerContext, Channel, ChannelBuffer)` for each frame. The default implementation returns a copy of the sub-region. For example, you could override this method to use an alternative `ChannelBufferFactory`.

If you are sure that the frame and its content are not accessed after the current `LengthFieldBasedFrameDecoder.decode(ChannelHandlerContext, Channel, ChannelBuffer)` call returns, you can even avoid memory copy by returning the sliced sub-region (i.e. `return buffer.slice(index, length)`). It's often useful when you convert the extracted frame into an object. Refer to the source code of `ObjectDecoder` to see how this method is overridden to avoid memory copy.

Overrides:
  `extractFrame` in class `LengthFieldBasedFrameDecoder`